/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.util.ArrayList;
import java.util.List;


import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.PartManager;

import jp.mosp.system.dao.MCodeDao;
import jp.mosp.system.dto.MCodeDto;
import jp.mosp.system.vo.YukyuInformationCardVo;

public class YukyuInformationCardAction extends MosPAction {

	//R}h
	private static final String CMD_YUKYU_INFO_SHOW 		= "S2700";	//\
	private static final String CMD_YUKYU_INFO_UPDATE		= "S2708";	//XV

	/**
	 * RXgN^
	 */
	public YukyuInformationCardAction() {
		super();
	}

	/**
	 * ANV
	 */
	public void action() throws Exception {
		// DBRlNV擾
		getConnection();
		// VXemF
		confirmSystemAuth();
		// VO̎擾yѐݒ
		YukyuInformationCardVo vo = new YukyuInformationCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VOyуtH[h̏
		setVo(vo);
		setUrl(vo.getRetUrl());
		// v_EXg쐬
		vo.aryPltCFKbn = getPltCFKbnArray();
		vo.aryPltCFMonth = util.getMonthArray();
		// R}h̏
		if (cmd.equals(CMD_YUKYU_INFO_SHOW)) {
			// \
			show(vo);
		} else if (cmd.equals(CMD_YUKYU_INFO_UPDATE)){
			// JzXVAXV
			regist(vo);
			// R~bg
			commit();			
			// \
			show(vo);
			// bZ[Wݒ
			vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * ݒ荀ڌ
	 * @param vo VoCX^X
	 * @throws Exception
	 */
	private void show(YukyuInformationCardVo vo) throws Exception {
		// LJz 
		String[] aryPaidHolidayInfo = getPaidHolidayInfo();
		// Jz
		vo.setPltCFMonth(aryPaidHolidayInfo[0]);
		// Jz
		vo.setTxtCFDays(aryPaidHolidayInfo[1]);
		// Jz敪
		vo.setPltCFKbn(aryPaidHolidayInfo[2]);
		// LxɎx	
		vo.setDefaultValues();
		vo.setFields(PartManager.mospcode(partInfo()).getPaidHolidayList());		
		// [hݒ
		vo.setMode(YukyuInformationCardVo.MODE_UPDATE);		
	}

	/**
	 * f[^XViJzځj
	 * @param vo ΏVO
	 * @param dto ΏDTO
	 * @throws Exception
	 */
	private void regist(YukyuInformationCardVo vo) throws Exception {
		// p[^̑ÓmF
		vo.validate();
		// DTȌ
		MCodeDto dto = new MCodeDto(); 
		dto.setTId(CommonConst.NAM_PAID_HOLIDAY);
		// Jz
		vo.setDtoFieldsCFMonth(dto);
		update(vo, dto);
		// Jz
		vo.setDtoFieldsCFDay(dto);
		update(vo, dto);
		// Jz敪
		vo.setDtoFieldsCFDivision(dto);	
		update(vo, dto);
		// f[^XV(x)
		update(vo);
	}

	/**
	 * f[^XViJzj
	 * @param vo
	 * @param dto
	 * @throws Exception
	 */
	private void update(YukyuInformationCardVo vo, MCodeDto dto) throws Exception {
		// DAȌ
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTO̍Ď擾
		MCodeDto retDto;
		// rmF
		chkExclusive(dao.findForKey(dto.getTId(), dto.getTCode()), dao.findForUpdate(dto.getTId(), dto.getTCode()), vo);
		// f[^̍XV
		dao.update(dto);
		// Abvf[g̃`FbN
		retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
	}

	/**
	 * f[^XV(x)
	 * @param vo ΏVO
	 * @throws Exception
	 */
	private void update(YukyuInformationCardVo vo) throws Exception {
		// DAȌ
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// XVO
		// e[ubN
		dao.tableLock(CommonConst.NAM_PAID_HOLIDAY + CommonConst.NAM_SUPPLY);
		// 폜
		dao.delete(CommonConst.NAM_PAID_HOLIDAY + CommonConst.NAM_SUPPLY);	
		// DTȌ
		List<MCodeDto> listCode = new ArrayList<MCodeDto>(20);
		vo.setDtoFields(listCode);
		for (int i = 0; i < listCode.size(); i++) {
			MCodeDto dto = listCode.get(i);
			if (dto.getTCode().equals("")) {
				continue;
			}
			// dmF
			chkDuplicate(dao.findForKey(dto.getTId(), dto.getTCode()), vo);
			// o^
			dao.insert(dto);
			// DTO̍Ď擾
			chkInsert(dao.findForKey(dto.getTId(), dto.getTCode()));
		}
	}

	/**
	 * Jz敪
	 * @return Jz敪z
	 */
	private String[][] getPltCFKbnArray() {
		// z̍쐬
		String[][] aryPosition = new String[2][2];
		for (int i = 0; i < aryPosition.length; i++) {
			if (i == 0) {
				aryPosition[i][0] = String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_CARRY_OVER_THIS_YEAR;
			} else {
				aryPosition[i][0] =  String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_CARRY_OVER_TOTAL;
			}
		}
		return aryPosition;
	}

}
